/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class lwc0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         lwc0.class,
         "lwc0",
         false,
         new ArgumentDecls()
             .add("cs", ArgumentMode.OUT, COP0.INFO)
             .add("offset", SHORT)
             .add("address", ArgumentMode.IN, REG.INFO),
         false,
         false,
         false,
         true,
         false,
         32,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final COP0 cs = (COP0) getArgument("cs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final REG address = (REG) getArgument("address", args);

      return new lwc0(cs, offset, address);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "lwc0",
          true,
          new ArgumentDecls()
              .add("cs", ArgumentMode.OUT, COP0.INFO)
              .add("offset", SHORT)
              .add("address", ArgumentMode.IN, REG.INFO),
          true,
          true,
          false,
          true,
          false,
          32
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final COP0 cs = (COP0) getArgument("cs", args);
      final Immediate offset = (Immediate) getArgument("offset", args);
      final REG address = (REG) getArgument("address", args);

      return new instruction(
        new lwc0(
          cs,
          offset,
          address
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final COP0 cs;
  public final Immediate offset;
  public final REG address;

  public lwc0(final COP0 cs, final Immediate offset, final REG address) {
    assert COP0.INFO.isSupported(cs);
    assert SHORT.equals(offset.getType());
    assert REG.INFO.isSupported(address);
    this.cs = cs;
    this.offset = offset;
    this.address = address;
  }

  @Override
  public String syntax() {
    return String.format("lwc0 %s, %d(%s)", cs.syntax(), offset.access().load().bigIntegerValue(), address.syntax());
  }

  @Override
  public String image() {
    return String.format("110000%s%s%s", address.image(), cs.image(), offset.access().load().toString());
  }

  @Override
  public void action() {
    cs.access().store(M.access(address.access().load().add(Data.signExtend(WORD, offset.access().load())).shiftRight(Data.valueOf(WORD, 0x2))).load());
  }
}
