/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.Shared.*;

public final class subu extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         subu.class,
         "subu",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, REG.INFO)
             .add("rs", ArgumentMode.IN, REG.INFO)
             .add("rt", ArgumentMode.IN, REG.INFO),
         false,
         false,
         false,
         false,
         false,
         0,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);

      return new subu(rd, rs, rt);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "subu",
          true,
          new ArgumentDecls()
              .add("rd", ArgumentMode.OUT, REG.INFO)
              .add("rs", ArgumentMode.IN, REG.INFO)
              .add("rt", ArgumentMode.IN, REG.INFO),
          true,
          true,
          false,
          false,
          false,
          0
      );
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final REG rd = (REG) getArgument("rd", args);
      final REG rs = (REG) getArgument("rs", args);
      final REG rt = (REG) getArgument("rt", args);

      return new instruction(
        new subu(
          rd,
          rs,
          rt
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  public final REG rd;
  public final REG rs;
  public final REG rt;

  public subu(final REG rd, final REG rs, final REG rt) {
    assert REG.INFO.isSupported(rd);
    assert REG.INFO.isSupported(rs);
    assert REG.INFO.isSupported(rt);
    this.rd = rd;
    this.rs = rs;
    this.rt = rt;
  }

  @Override
  public String syntax() {
    return String.format("subu %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
  }

  @Override
  public String image() {
    return String.format("000000%s%s%s00000100011", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action() {
    rd.access().store(rs.access().load().subtract(rt.access().load()));
  }
}
