/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;

import static ru.ispras.microtesk.model.vliw.Shared.*;

public final class MUL_S extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         MUL_S.class,
         "MUL_S",
         false,
         new ArgumentDecls()
             .add("fd", ArgumentMode.OUT, F.INFO)
             .add("fs", ArgumentMode.IN, F.INFO)
             .add("ft", ArgumentMode.IN, F.INFO),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public Operation create(final Map<String, Primitive> args) {
      final F fd = (F) getArgument("fd", args);
      final F fs = (F) getArgument("fs", args);
      final F ft = (F) getArgument("ft", args);

      return new MUL_S(fd, fs, ft);
    }
  }

  public static final IInfo INFO = new Info();

  public final F fd;
  public final F fs;
  public final F ft;

  public MUL_S(final F fd, final F fs, final F ft) {
    assert F.INFO.isSupported(fd);
    assert F.INFO.isSupported(fs);
    assert F.INFO.isSupported(ft);
    this.fd = fd;
    this.fs = fs;
    this.ft = ft;
  }

  @Override
  public String syntax() {
    return String.format("MUL_S %s, %s, %s", fd.syntax(), fs.syntax(), ft.syntax());
  }

  @Override
  public String image() {
    return String.format("01000110000%s%s%s000010", ft.image(), fs.image(), fd.image());
  }

  @Override
  public void action() {
    fd.access().store(fs.access().load().multiply(ft.access().load()));
  }
}
